import sys
import os
import subprocess
import argparse
import matchmaker.file as jsf
import matchmaker.run_all as run_all
import matchmaker.functions as func
from timeit import default_timer as timer

def match_model():
    parser = argparse.ArgumentParser()
    parser.add_argument('-d', nargs='?', help='model directory')
    args = parser.parse_args()
    NPmodeldir=jsf.proper_dir_path(args.d)
    inputfiledir=func.get_path('input')+"/"
    modeldir=func.get_path('models')+"/"

    inputfilelist=['new_input_L2.dat','new_input_L4.dat','new_input_0F.dat','new_input_2F_0S_3D.dat','new_input_2F_1S_2D.dat','new_input_2F_2S_1D.dat','new_input_2F_3S_0D.dat','new_input_4F_LLLL.dat','new_input_4F_LLRR_LRRL.dat','new_input_4F_LRLR.dat','new_input_4F_RRRR.dat']
    effmodeldir=['L2SM/','L4SM/','L6SM_0F/','L6SM_2F_0S_3D/','L6SM_2F_1S_2D/','L6SM_2F_2S_1D/','L6SM_2F_3S_0D/','L6SM_4F_LLLL/','L6SM_4F_LLRR_LRRL/','L6SM_4F_LRLR/','L6SM_4F_RRRR']
    #if os.path.isdir(modeldir+NPmodeldir):
    if os.path.isdir(NPmodeldir):
        for ipart,partfile in enumerate(inputfilelist):
            run_all.run_all(inputfiledir+partfile,modeldir+effmodeldir[ipart])
            run_all.run_all(inputfiledir+partfile,NPmodeldir)

